m1 = 3;
C1 = 27;

m2 = 1;
C2 = 13;
D2 = 4;

//Modell des Gesamtsystems, wobei gilt:
//y = [x1,v1,x2,v2]'
function f = rechteSeite(t,y)
    f(1,1) =                                  y(2,1);
    f(2,1) = (-C1/m1-C2/m1)*y(1,1) + (-D2/m1)*y(2,1) + ( C2/m1)*y(3,1) + ( D2/m1)*y(4,1);
    f(3,1) =                                                                      y(4,1);
    f(4,1) =        (C2/m2)*y(1,1) + ( D2/m2)*y(2,1) + (-C2/m2)*y(3,1) + (-D2/m2)*y(4,1);
endfunction

//Die zu optimierende Funktion bekommt Parameter bergeben,
//fr die sie berechnet, wie schlecht, diese Parameter sind.
//Es gilt, diesen Fehler zu minimieren.
//Hier ist der "Fehler" die Gesamtenergie am Ende der Simulation.
//Diese gilt es durch geschickte Wahl der Parameter C2 und D2 zu optimieren.
function fehler = berechneFehler(neuC2,neuD2)
    C2 = neuC2;
    D2 = neuD2;
    t=0:0.05:10;
    y0 = [0.5,0,0,0]';
    t0=0;
    y = ode(y0,t0,t,rechteSeite);
    [zeilen,spalten] = size(y) 
    x1 = y(1,spalten);
    v1 = y(2,spalten);
    x2 = y(3,spalten);
    v2 = y(4,spalten);
    fehler = 0.5*C1*x1^2 + 0.5*m1*v1^2 + 0.5*C2*x2^2 + 0.5*m2*v2^2;
    plot(t,y(1,:),t,y(3,:));
endfunction


//Gesamtenergie am Ende der Simulation als Grundlage der Bewertung der
//Gte der Tilgung:

fehler = berechneFehler(13,4)
fehler = berechneFehler(12,4)
fehler = berechneFehler(14,4)
fehler = berechneFehler(13,5)
fehler = berechneFehler(13,6)

//Revision: Nur bei gegenstzlicher Schwingungsform sind gleiche Eigenfrequenzen zur Tilgung geeignet.
//          Diese mte aber aktiv in Phase gehalten werden.
//          Sie bleibt besser in Phase, wenn die Dmpfung gering ist, s. 004b_anderer_eigenmode.sce.










