//Anpassungen, um berechneFehler in optim verwenden zu knnen:
m1 = 3;
C1 = 27;

m2 = 1;
C2 = 13;
D2 = 4;

function f = rechteSeite(t,y)
    f(1,1) =                                  y(2,1);
    f(2,1) = (-C1/m1-C2/m1)*y(1,1) + (-D2/m1)*y(2,1) + ( C2/m1)*y(3,1) + ( D2/m1)*y(4,1);
    f(3,1) =                                                                      y(4,1);
    f(4,1) =        (C2/m2)*y(1,1) + ( D2/m2)*y(2,1) + (-C2/m2)*y(3,1) + (-D2/m2)*y(4,1);
endfunction

t=0:0.05:10;
y0 = [0.5,0,0,0]';
t0=0;
y = ode(y0,t0,t,rechteSeite);

//Mit folgender Angabe, werden die aufgefhrten Variablen und Funktionen 
//global zugnglich.
//Dies ist notwendig, damit nach bergabe der Funktion "berechneFehler" an die Funktion
//"optim" noch "rechteSeite" von "berechneFehler" aufgerufen werden kann.
//ACHTUNG: Die hier globalisierten Variablen mssen bereits existieren.
global m1,C1,m2,C2,D2,t,y,rechteSeite;

function fehler = berechneFehler(parameter)
    C2 = parameter(1,1);
    D2 = parameter(1,2);
    t=0:0.05:10;
    y0 = [0.5,0,0,0]';
    t0=0;
    y = ode(y0,t0,t,rechteSeite);
    [zeilen,spalten] = size(y) 
    x1 = y(1,spalten);
    v1 = y(2,spalten);
    x2 = y(3,spalten);
    v2 = y(4,spalten);
    fehler = 0.5*C1*x1^2 + 0.5*m1*v1^2 + 0.5*C2*x2^2 + 0.5*m2*v2^2;
    //plot(t,y(1,:),t,y(3,:));
endfunction

p0 = [13,4];

fehler = berechneFehler(p0)
